const { MessageEmbed, MessageActionRow, MessageButton } = require("discord.js");
const { EMBED_COLORS, SUPPORT_SERVER, DASHBOARD } = require("@root/config");
const { timeformat } = require("@utils/miscUtils");
const os = require("os");
const { outdent } = require("outdent");

module.exports = (client) => {
  let desc = "";
  desc += `Successfully update to the newer version\n`;
  desc += `❒ Bot Version: 3.9.0\n`;
  desc += `❒ Bot Maker: <@334307216926703616>\n`;
  desc += `❒ Bot Manager: Kiera Bot Development Team\n`;
  desc += `❒ Copyright Owner: © Kiera Bot 2022\n`;
  desc += `❒ Websocket Ping: ${client.ws.ping} ms\n`;

  const embed = new MessageEmbed()
    .setTitle("Bot Information")
    .setColor(EMBED_COLORS.BOT_EMBED)
    .setThumbnail(client.user.displayAvatarURL())
    .setDescription(desc)
    .addField(
      "Bot Update Information:",
      outdent`
        ❯ now search command has been fixed, and added new ability to play music from profile in spotify
        `,
      true
    )
    .addField("Node Js version", process.versions.node, false);

  // Buttons
  let components = [];
  components.push(new MessageButton().setLabel("Invite Link").setURL(client.getInvite()).setStyle("LINK"));

  if (SUPPORT_SERVER) {
    components.push(new MessageButton().setLabel("Support Server").setURL(SUPPORT_SERVER).setStyle("LINK"));
  }

  if (DASHBOARD.enabled) {
    components.push(new MessageButton().setLabel("Dashboard Link").setURL(DASHBOARD.baseURL).setStyle("LINK"));
  }

  let buttonsRow = new MessageActionRow().addComponents(components);

  return { embeds: [embed], components: [buttonsRow] };
};
